import { AxiosResponse } from 'axios';
import { GetOptions, PostOptions, PutOptions } from './common/interfaces';
import { ApiKeys } from './api-keys/api-keys';
import { Domains } from './domains/domains';
import { Emails } from './emails/emails';
import { CreateEmailOptions, CreateEmailResponse } from './emails/interfaces';
export declare class Resend {
    readonly key?: string | undefined;
    readonly baseUrl: string;
    private readonly headers;
    private readonly request;
    readonly apiKeys: ApiKeys;
    readonly domains: Domains;
    readonly emails: Emails;
    constructor(key?: string | undefined);
    post<T>(path: string, entity?: any, options?: PostOptions): Promise<T>;
    get<T>(path: string, options?: GetOptions): Promise<T>;
    put(path: string, entity: any, options?: PutOptions): Promise<AxiosResponse>;
    delete(path: string, query?: any): Promise<AxiosResponse>;
    sendEmail(data: CreateEmailOptions): Promise<CreateEmailResponse>;
}
